Last Comment Bug 668743 - ANGLE fails to load on WinXP after upgrade from r653 to r686
: ANGLE fails to load on WinXP after upgrade from r653 to r686
Status: RESOLVED FIXED
[qa-]
: regression
Product: Core
Classification: Components
Component: Graphics (show other bugs)
: 6 Branch
: All Other
: -- normal with 1 vote (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-07-01 01:06 PDT by jonrandy
Modified: 2011-09-22 15:42 PDT (History)
12 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
+
fixed
+
fixed


Attachments
angle r688 (6.77 KB, patch)
2011-07-06 18:25 PDT, Benoit Jacob [:bjacob] (mostly away)
jacob.benoit.1: review+
Details | Diff | Splinter Review
attempt at delayloading dwmapi.dll (617 bytes, patch)
2011-07-06 18:25 PDT, Benoit Jacob [:bjacob] (mostly away)
no flags Details | Diff | Splinter Review
delay-load dwmapi.dll (685 bytes, patch)
2011-07-26 08:33 PDT, Benoit Jacob [:bjacob] (mostly away)
no flags Details | Diff | Splinter Review
delayload dwmapi.dll and remove list of tests failing only on WinXP (2.04 KB, patch)
2011-07-26 15:12 PDT, Benoit Jacob [:bjacob] (mostly away)
jmuizelaar: review+
christian: approval‑mozilla‑aurora+
christian: approval‑mozilla‑beta+
Details | Diff | Splinter Review

Description jonrandy 2011-07-01 01:06:12 PDT
User Agent: Mozilla/5.0 (Windows NT 5.1; rv:6.0a2) Gecko/20110630 Firefox/6.0a2
Build ID: 20110630042003

Steps to reproduce:

Updated aurora last night (June 30th) 


Actual results:

Web GL support has gone - doesn't work on any sites


Expected results:

Web GL should still work

GFX section of about:support - 



        
Adapter Description  Mobile Intel(R) 965 Express Chipset Family
Vendor ID8086
Device ID2a02
Adapter RAM Unknown
Adapter Drivers igxprd32
Driver Version 6.14.10.5218
Driver Date1-13-2010 
WebGL Renderer false
GPU Accelerated Windows 0/1
Comment 1 Boris Zbarsky [:bz] 2011-07-01 08:46:56 PDT
Requesting tracking, since this seems to be a regression.
Comment 2 Benoit Jacob [:bjacob] (mostly away) 2011-07-01 09:09:12 PDT
Can you please:
 1) confirm that the problem persists after rebooting your computer.
 2) Use the archived builds to narrow the regression window
      http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/
    Notice that there are nightly aurora builds there.
 3) When you've found when it regressed, go to about:buildconfig to see the corresponding changesets ("built from ...")
Comment 3 jonrandy 2011-07-01 09:28:34 PDT
(In reply to comment #2)
> Can you please:
>  1) confirm that the problem persists after rebooting your computer.
>  2) Use the archived builds to narrow the regression window
>       http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/
>     Notice that there are nightly aurora builds there.
>  3) When you've found when it regressed, go to about:buildconfig to see the
> corresponding changesets ("built from ...")

1. Problem persists after reboot
2. I update aurora nightly just after 10pm (Bangkok time) - this seems to be the time when the new update is available. WebGL was working fine on 29th June and on the 30th of June. It stopped working after the update that came in on the 30th. I've just updated again (1st July) and it is still not working
3. Changeset from 1st July update : https://hg.mozilla.org/releases/mozilla-aurora/rev/4afee8a13b96
Comment 4 jonrandy 2011-07-01 20:45:48 PDT
Interestingly, if I use a clean profile, WebGL is back. Not sure if the below will help. Maybe you can see a setting/add-on that could be breaking stuff? I don't really want to rebuild my profile and go through all the fiddly moving of settings from different add-ons



  Application Basics

        Name
        Firefox

        Version
        6.0a2

        User Agent
        Mozilla/5.0 (Windows NT 5.1; rv:6.0a2) Gecko/20110701 Firefox/6.0a2

        Profile Directory

          Open Containing Folder

        Enabled Plugins

          about:plugins

        Build Configuration

          about:buildconfig

  Extensions

        Name

        Version

        Enabled

        ID

        Adblock Plus
        1.3.9
        true
        {d10d0bf8-f5b5-c8b4-a8b2-2b9879e08c5d}

        Add-on Compatibility Reporter
        0.8.5
        true
        compatibility@addons.mozilla.org

        British English Dictionary
        1.19.1
        true
        en-GB@dictionaries.addons.mozilla.org

        Delicious Bookmarks
        2.1.106
        true
        {2fa4ed95-0317-4c6a-a74c-5f3e3912c1f9}

        Download Statusbar
        0.9.8
        true
        {D4DD63FA-01E4-46a7-B6B1-EDAB7D6AD389}

        F1 by Mozilla Labs
        0.8.3
        true
        ffshare@mozilla.org

        Firebug
        1.7.2
        true
        firebug@software.joehewitt.com

        FireGestures
        1.6.4
        true
        firegestures@xuldev.org

        Greasemonkey
        2011.06.24.nightly
        true
        {e4a8a97b-f2ed-450b-b12d-ee082ba24781}

        HTTPS-Everywhere
        0.9.7
        true
        https-everywhere@eff.org

        Instaright!
        0.4.1.2
        true
        {1d682819-bef2-4a75-8ffa-adf3733f5557}

        is.gd Creator
        0.2.2
        true
        isgdcreator@postspectacular.com

        Last tab close button
        0.3.4
        true
        last-tab-close-button@victor.sacharin

        New Tab Homepage
        0.4.3
        true
        {66E978CD-981F-47DF-AC42-E3CF417C1467}

        QuickRestart
        1.1.6
        true
        {F645A8C9-E969-42D9-B3F3-F325537222FD}

        Session Manager
        0.7.5
        true
        {1280606b-2510-4fe0-97ef-9b5a22eafe30}

        SmoothWheel (AMO)
        0.45.6.20100202.1
        true
        {5F590AA2-1221-4113-A6F4-A4BB62414FAC}

        Ubiquity
        0.6.1pre
        true
        ubiquity@labs.mozilla.com

        Vacuum Places Improved
        1.2
        true
        VacuumPlacesImproved@lultimouomo-gmail.com

        Web Developer
        1.1.9
        true
        {c45c406e-ab73-11d8-be73-000a95be3b12}

        ColorZilla
        2.5.5.1
        false
        {6AC85730-7D0F-4de0-B3FA-21142DD85326}

        Feedback
        1.1.2
        false
        testpilot@labs.mozilla.com

        FireSnarl
        1.1.3
        false
        firesnarl@snarl.de

        Java Quick Starter
        1.0
        false
        jqs@sun.com

        Microsoft .NET Framework Assistant
        0.0.0
        false
        {20a82645-c095-46ed-80e3-08825760534b}

        Pencil
        1.2.0
        false
        pencil@evolus.vn

        S3 Firefox Organizer(S3Fox)
        0.6
        false
        {7CEA821D-3DAB-4238-B424-BF7324531750}

        SearchPreview
        5.0.3
        false
        {EF522540-89F5-46b9-B6FE-1829E2B572C6}

        User Agent Switcher
        0.7.3
        false
        {e968fc70-8f95-4ab9-9e79-304de2a71ee1}

  Modified Preferences

      Name

      Value

        accessibility.typeaheadfind.flashBar
        0

        browser.link.open_newwindow
        2

        browser.places.smartBookmarksVersion
        2

        browser.startup.homepage
        http://myfav.es/

        browser.startup.homepage_override.buildID
        20110701042007

        browser.startup.homepage_override.mstone
        rv:6.0a2

        dom.disable_open_during_load
        false

        dom.max_script_run_time
        0

        extensions.checkCompatibility
        false

        extensions.checkCompatibility.3.6
        false

        extensions.checkCompatibility.3.6b
        false

        extensions.checkCompatibility.3.6p
        false

        extensions.checkCompatibility.3.6pre
        false

        extensions.checkCompatibility.3.7a
        false

        extensions.checkCompatibility.4.0
        false

        extensions.checkCompatibility.4.0b
        false

        extensions.checkCompatibility.4.0p
        false

        extensions.checkCompatibility.4.0pre
        false

        extensions.checkCompatibility.4.0rc
        false

        extensions.checkCompatibility.4.0rc1
        false

        extensions.checkCompatibility.4.2
        false

        extensions.checkCompatibility.4.2a
        false

        extensions.checkCompatibility.4.2b
        false

        extensions.checkCompatibility.4.2p
        false

        extensions.checkCompatibility.4.2pre
        false

        extensions.checkCompatibility.5.0
        false

        extensions.checkCompatibility.5.0a
        false

        extensions.checkCompatibility.5.0b
        false

        extensions.checkCompatibility.5.0p
        false

        extensions.checkCompatibility.5.0pre
        false

        extensions.checkCompatibility.6.0
        false

        extensions.checkCompatibility.6.0a
        false

        extensions.checkCompatibility.7.0
        false

        extensions.checkCompatibility.7.0a
        false

        extensions.checkCompatibility.8.0
        false

        extensions.checkCompatibility.8.0a
        false

        extensions.checkCompatibility.nightly
        false

        extensions.lastAppVersion
        6.0a2

        font.language.group
        x-western

        font.name.sans-serif.th
        Arial Unicode MS

        gfx.blacklist.direct2d
        2

        gfx.blacklist.layers.direct3d10
        2

        gfx.blacklist.layers.direct3d10-1
        2

        gfx.direct2d.disabled
        true

        layers.acceleration.disabled
        true

        network.cookie.prefsMigrated
        true

        network.websocket.override-security-block
        true

        places.database.lastMaintenance
        1309537991

        places.history.expiration.transient_current_max_pages
        96321

        print.print_printer
        Microsoft XPS Document Writer

        print.printer_Canon_MP240_series_Printer.print_bgcolor
        true

        print.printer_Canon_MP240_series_Printer.print_bgimages
        true

        print.printer_Canon_MP240_series_Printer.print_command

        print.printer_Canon_MP240_series_Printer.print_downloadfonts
        false

        print.printer_Canon_MP240_series_Printer.print_edge_bottom
        0

        print.printer_Canon_MP240_series_Printer.print_edge_left
        0

        print.printer_Canon_MP240_series_Printer.print_edge_right
        0

        print.printer_Canon_MP240_series_Printer.print_edge_top
        0

        print.printer_Canon_MP240_series_Printer.print_evenpages
        true

        print.printer_Canon_MP240_series_Printer.print_footercenter

        print.printer_Canon_MP240_series_Printer.print_footerleft
        &PT

        print.printer_Canon_MP240_series_Printer.print_footerright
        &D

        print.printer_Canon_MP240_series_Printer.print_headercenter

        print.printer_Canon_MP240_series_Printer.print_headerleft
        &T

        print.printer_Canon_MP240_series_Printer.print_headerright
        &U

        print.printer_Canon_MP240_series_Printer.print_in_color
        true

        print.printer_Canon_MP240_series_Printer.print_margin_bottom
        0.236111119389534

        print.printer_Canon_MP240_series_Printer.print_margin_left
        0.236111119389534

        print.printer_Canon_MP240_series_Printer.print_margin_right
        0.236111119389534

        print.printer_Canon_MP240_series_Printer.print_margin_top
        0.236111119389534

        print.printer_Canon_MP240_series_Printer.print_oddpages
        true

        print.printer_Canon_MP240_series_Printer.print_orientation
        0

        print.printer_Canon_MP240_series_Printer.print_page_delay
        50

        print.printer_Canon_MP240_series_Printer.print_paper_data
        9

        print.printer_Canon_MP240_series_Printer.print_paper_height
        11.00

        print.printer_Canon_MP240_series_Printer.print_paper_size_type
        0

        print.printer_Canon_MP240_series_Printer.print_paper_size_unit
        1

        print.printer_Canon_MP240_series_Printer.print_paper_width
        8.50

        print.printer_Canon_MP240_series_Printer.print_reversed
        false

        print.printer_Canon_MP240_series_Printer.print_scaling
        0.90

        print.printer_Canon_MP240_series_Printer.print_shrink_to_fit
        true

        print.printer_Canon_MP240_series_Printer.print_to_file
        false

        print.printer_Canon_MP240_series_Printer.print_unwriteable_margin_bottom
        0

        print.printer_Canon_MP240_series_Printer.print_unwriteable_margin_left
        0

        print.printer_Canon_MP240_series_Printer.print_unwriteable_margin_right
        0

        print.printer_Canon_MP240_series_Printer.print_unwriteable_margin_top
        0

        print.printer_Microsoft_XPS_Document_Writer.print_bgcolor
        true

        print.printer_Microsoft_XPS_Document_Writer.print_bgimages
        true

        print.printer_Microsoft_XPS_Document_Writer.print_command

        print.printer_Microsoft_XPS_Document_Writer.print_downloadfonts
        false

        print.printer_Microsoft_XPS_Document_Writer.print_edge_bottom
        0

        print.printer_Microsoft_XPS_Document_Writer.print_edge_left
        0

        print.printer_Microsoft_XPS_Document_Writer.print_edge_right
        0

        print.printer_Microsoft_XPS_Document_Writer.print_edge_top
        0

        print.printer_Microsoft_XPS_Document_Writer.print_evenpages
        true

        print.printer_Microsoft_XPS_Document_Writer.print_footercenter

        print.printer_Microsoft_XPS_Document_Writer.print_footerleft
        &PT

        print.printer_Microsoft_XPS_Document_Writer.print_footerright
        &D

        print.printer_Microsoft_XPS_Document_Writer.print_headercenter

        print.printer_Microsoft_XPS_Document_Writer.print_headerleft
        &T

        print.printer_Microsoft_XPS_Document_Writer.print_headerright
        &U

        print.printer_Microsoft_XPS_Document_Writer.print_in_color
        true

        print.printer_Microsoft_XPS_Document_Writer.print_margin_bottom
        0.236111119389534

        print.printer_Microsoft_XPS_Document_Writer.print_margin_left
        0.236111119389534

        print.printer_Microsoft_XPS_Document_Writer.print_margin_right
        0.236111119389534

        print.printer_Microsoft_XPS_Document_Writer.print_margin_top
        0.236111119389534

        print.printer_Microsoft_XPS_Document_Writer.print_oddpages
        true

        print.printer_Microsoft_XPS_Document_Writer.print_orientation
        0

        print.printer_Microsoft_XPS_Document_Writer.print_page_delay
        50

        print.printer_Microsoft_XPS_Document_Writer.print_paper_data
        9

        print.printer_Microsoft_XPS_Document_Writer.print_paper_height
        11.00

        print.printer_Microsoft_XPS_Document_Writer.print_paper_size_type
        0

        print.printer_Microsoft_XPS_Document_Writer.print_paper_size_unit
        1

        print.printer_Microsoft_XPS_Document_Writer.print_paper_width
        8.50

        print.printer_Microsoft_XPS_Document_Writer.print_reversed
        false

        print.printer_Microsoft_XPS_Document_Writer.print_scaling
        0.90

        print.printer_Microsoft_XPS_Document_Writer.print_shrink_to_fit
        true

        print.printer_Microsoft_XPS_Document_Writer.print_to_file
        false

        print.printer_Microsoft_XPS_Document_Writer.print_unwriteable_margin_bottom
        0

        print.printer_Microsoft_XPS_Document_Writer.print_unwriteable_margin_left
        0

        print.printer_Microsoft_XPS_Document_Writer.print_unwriteable_margin_right
        0

        print.printer_Microsoft_XPS_Document_Writer.print_unwriteable_margin_top
        0

        print.printer_OnAsia_Network_Printer.print_bgcolor
        true

        print.printer_OnAsia_Network_Printer.print_bgimages
        true

        print.printer_OnAsia_Network_Printer.print_command

        print.printer_OnAsia_Network_Printer.print_downloadfonts
        false

        print.printer_OnAsia_Network_Printer.print_edge_bottom
        0

        print.printer_OnAsia_Network_Printer.print_edge_left
        0

        print.printer_OnAsia_Network_Printer.print_edge_right
        0

        print.printer_OnAsia_Network_Printer.print_edge_top
        0

        print.printer_OnAsia_Network_Printer.print_evenpages
        true

        print.printer_OnAsia_Network_Printer.print_footercenter

        print.printer_OnAsia_Network_Printer.print_footerleft
        &PT

        print.printer_OnAsia_Network_Printer.print_footerright
        &D

        print.printer_OnAsia_Network_Printer.print_headercenter

        print.printer_OnAsia_Network_Printer.print_headerleft
        &T

        print.printer_OnAsia_Network_Printer.print_headerright
        &U

        print.printer_OnAsia_Network_Printer.print_in_color
        true

        print.printer_OnAsia_Network_Printer.print_margin_bottom
        0.236111119389534

        print.printer_OnAsia_Network_Printer.print_margin_left
        0.236111119389534

        print.printer_OnAsia_Network_Printer.print_margin_right
        0.236111119389534

        print.printer_OnAsia_Network_Printer.print_margin_top
        0.236111119389534

        print.printer_OnAsia_Network_Printer.print_oddpages
        true

        print.printer_OnAsia_Network_Printer.print_orientation
        0

        print.printer_OnAsia_Network_Printer.print_page_delay
        50

        print.printer_OnAsia_Network_Printer.print_paper_data
        9

        print.printer_OnAsia_Network_Printer.print_paper_height
        11.00

        print.printer_OnAsia_Network_Printer.print_paper_size_type
        0

        print.printer_OnAsia_Network_Printer.print_paper_size_unit
        1

        print.printer_OnAsia_Network_Printer.print_paper_width
        8.50

        print.printer_OnAsia_Network_Printer.print_reversed
        false

        print.printer_OnAsia_Network_Printer.print_scaling
        0.90

        print.printer_OnAsia_Network_Printer.print_shrink_to_fit
        true

        print.printer_OnAsia_Network_Printer.print_to_file
        false

        print.printer_OnAsia_Network_Printer.print_unwriteable_margin_bottom
        0

        print.printer_OnAsia_Network_Printer.print_unwriteable_margin_left
        0

        print.printer_OnAsia_Network_Printer.print_unwriteable_margin_right
        0

        print.printer_OnAsia_Network_Printer.print_unwriteable_margin_top
        0

        privacy.cpd.cookies
        false

        privacy.cpd.downloads
        false

        privacy.cpd.extensions-sessionmanager
        false

        privacy.cpd.formdata
        false

        privacy.cpd.history
        false

        privacy.cpd.sessions
        false

        privacy.donottrackheader.enabled
        true

        privacy.sanitize.migrateFx3Prefs
        true

        privacy.sanitize.timeSpan
        0

        security.warn_viewing_mixed
        false

  Graphics

        Adapter Description
        Mobile Intel(R) 965 Express Chipset Family

        Vendor ID
        8086

        Device ID
        2a02

        Adapter RAM
        Unknown

        Adapter Drivers
        igxprd32

        Driver Version
        6.14.10.5218

        Driver Date
        1-13-2010

        WebGL Renderer
        false

        GPU Accelerated Windows
        0/1
Comment 5 jonrandy 2011-07-01 21:27:04 PDT
Actually, I take that back - just created another new profile and now it is NOT working again
Comment 6 jonrandy 2011-07-01 21:42:15 PDT
OK, the only way it will kind of work now is to create a new profile, then set the force_enabled setting to true. Doesn't work well like this though - no textures, slow and crashes frequently.

Have performed system tests on my graphics card - all is working ok and hardware accelerated 3d working fine on all other stuff
Comment 7 Benoit Jacob [:bjacob] (mostly away) 2011-07-01 21:52:15 PDT
OK. There is nothing between the June 30 and the July 1 Aurora builds that could reasonably explain this regression. However, between June 29 and June 30 there is something could could conceivably be linked to it (the ANGLE update). It could be that you didn't actually receive an update on June 30 so the regression could have been present already in the June 30 build without affecting you until the next update.

Can you please download these archived Aurora builds and try them:

June 29 Aurora build:
http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/2011-06-29-04-20-07-mozilla-aurora/firefox-6.0a2.en-US.win32.zip

June 30 Aurora build:
http://ftp.mozilla.org/pub/mozilla.org/firefox/nightly/2011-06-30-04-20-03-mozilla-aurora/firefox-6.0a2.en-US.win32.zip

My theory is that the June 29 build will work and the June 30 build will fail.
Comment 8 jonrandy 2011-07-01 23:47:54 PDT
Your theory is 100% correct. 1st build works, 2nd build fails
Comment 9 Benoit Jacob [:bjacob] (mostly away) 2011-07-02 09:44:18 PDT
Filed ANGLE bug 177
http://code.google.com/p/angleproject/issues/detail?id=177

The regression window is
http://hg.mozilla.org/releases/mozilla-aurora/pushloghtml?fromchange=d8b00ee31575&tochange=9eabe65eb25a
The ANGLE update from 653 to 686 is the obvious suspect here.
Comment 10 Benoit Jacob [:bjacob] (mostly away) 2011-07-04 07:36:07 PDT
In order to make 100% sure that it's really the ANGLE update that caused the regression, can you please try these two builds, they differ only by this change:

Before the ANGLE update:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/bjacob@mozilla.com-78dafb543669

After the ANGLE update:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/bjacob@mozilla.com-fe3eca07acda

Thanks very much for your report and your help investigating this.
Comment 11 Benoit Jacob [:bjacob] (mostly away) 2011-07-04 07:36:40 PDT
(These builds will become available in a few hours)
Comment 12 jonrandy 2011-07-04 18:27:05 PDT
Build before ANGLE update: WebGL fine
Build after ANGLE update:  WebGL dead
Comment 13 Benoit Jacob [:bjacob] (mostly away) 2011-07-05 10:52:43 PDT
Thank you very much for checking that. Can you check this new build (will be available in a couple of hours)

http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/bjacob@mozilla.com-c365c6db6fb1

It's the current Aurora plus ANGLE r688 which an ANGLE developer suggested might fix the problem.
Comment 14 jonrandy 2011-07-05 18:39:48 PDT
No WebGL for me on that one either
Comment 15 Benoit Jacob [:bjacob] (mostly away) 2011-07-06 07:19:07 PDT
Thanks for checking that.
Comment 16 daniel-bzmz 2011-07-06 13:38:51 PDT
Checked in ANGLE r701 which should fix this.  The dwmapi DLL delay load was not specified properly in the release build.  This should affect all WinXP systems.
Comment 17 Benoit Jacob [:bjacob] (mostly away) 2011-07-06 18:13:44 PDT
Thanks, but this change only affects a .vcproj file which we don't use, since we have our own makefile. We need to find the equivalent way of doing this DelayLoadDLLs="dwmapi.dll". A colleague suggests this linker option:

   /delayload:dwmapi.dll
Comment 18 Benoit Jacob [:bjacob] (mostly away) 2011-07-06 18:25:02 PDT
Created attachment 544390 [details] [diff] [review]
angle r688

this is ANGLE r688, r=upstream
Comment 19 Benoit Jacob [:bjacob] (mostly away) 2011-07-06 18:25:55 PDT
Created attachment 544391 [details] [diff] [review]
attempt at delayloading dwmapi.dll

This is trying to port ANGLE r701 to our buildsystem, let's see if that works before asking for review.
Comment 20 Benoit Jacob [:bjacob] (mostly away) 2011-07-06 18:26:43 PDT
A new build with this new fix will be available here in a few hours, please try and report:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/bjacob@mozilla.com-bee2e33b7c0c
Comment 21 jonrandy 2011-07-07 02:31:30 PDT
Build failed?
Comment 22 Benoit Jacob [:bjacob] (mostly away) 2011-07-08 19:16:28 PDT
Meh, indeed the linking failed. From the log:


d:/mozilla-build/python25/python2.5.exe /e/builds/moz2_slave/try-w32/build/config/pythonpath.py -I../../../../config /e/builds/moz2_slave/try-w32/build/config/expandlibs_exec.py --uselist -- link -NOLOGO -DLL -OUT:libEGL.dll -PDB:libEGL.pdb -SUBSYSTEM:WINDOWS  atom.obj cpp.obj cppstruct.obj memory.obj scanner.obj symbols.obj tokens.obj Compiler.obj InfoSink.obj Initialize.obj InitializeDll.obj Intermediate.obj intermOut.obj IntermTraverse.obj MozAngleLink.obj parseConst.obj ParseHelper.obj PoolAlloc.obj QualifierAlive.obj RemoveTree.obj ShaderLang.obj SymbolTable.obj VariableInfo.obj compilerdebug.obj ossource_win.obj util.obj ValidateLimitations.obj ForLoopUnroll.obj MapLongVariableNames.obj glslang_lex.obj glslang_tab.obj CodeGenHLSL.obj OutputHLSL.obj TranslatorHLSL.obj UnfoldSelect.obj SearchSymbol.obj debug.obj Config.obj Display.obj libEGL.obj main.obj Surface.obj    ./module.res -LARGEADDRESSAWARE -NXCOMPAT -DYNAMICBASE -SAFESEH  -DEBUG -DEBUGTYPE:CV -MANIFEST:NO -LIBPATH:"e:/builds/moz2_slave/try-w32/build/obj-firefox/memory/jemalloc/crtsrc/build/intel" -NODEFAULTLIB:msvcrt -NODEFAULTLIB:msvcrtd -NODEFAULTLIB:msvcprt -NODEFAULTLIB:msvcprtd -DEFAULTLIB:mozcrt19 -DEFAULTLIB:mozcpp19 -DEBUG -OPT:REF -LTCG:PGINSTRUMENT -DEF:e:/builds/moz2_slave/try-w32/build/gfx/angle/src/libEGL/libEGL.def    "d:\sdks\dx10/lib/x86/d3d9.lib" "d:\sdks\dx10/lib/x86/dxguid.lib" "../../../../dist/lib/libGLESv2.lib" "dwmapi.lib" "/delayload:dwmapi.dll" kernel32.lib user32.lib gdi32.lib winmm.lib wsock32.lib advapi32.lib   
   Creating library libEGL.lib and object libEGL.exp
dwmapi.lib(dwmapi.dll) : error LNK2001: unresolved external symbol ___delayLoadHelper2@8
dwmapi.lib(dwmapi.dll) : error LNK2001: unresolved external symbol ___delayLoadHelper2@8
libEGL.dll : fatal error LNK1120: 1 unresolved externals
Comment 23 Asa Dotzler [:asa] 2011-07-17 23:55:28 PDT
Do we have any indication how widespread this failure is for users?
Comment 24 vitar 2011-07-22 03:29:41 PDT
(In reply to comment #23)
> Do we have any indication how widespread this failure is for users?

Well, I've noted this yesterday on the 7.0a2-20110720

about:support on load throws a warning about an absense of "usable webgl context" into console and shows "false" abt a "WebGL Renderer".
Any plays with any "force" or "native" or even switch to the mesa renderer didn't helps.

XP SP3, Intel 945GM, not blacklisted drivers, in the other apps both GL and D3D(9) works fine.
Comment 25 daniel-bzmz 2011-07-22 05:53:13 PDT
If dwmapi.dll isn't being delay loaded properly, it will affect all WinXP systems (since that library is only available in Vista and later)
Comment 26 Benoit Jacob [:bjacob] (mostly away) 2011-07-24 22:06:08 PDT
The weird thing is that this doesn't seem to affect our WinXP test slaves.

Will look into it ASAP but the obvious fix of rolling back this ANGLE upgrade wouldn't be very satisfactory since we want to stay close to current ANGLE to receive security fixes. It's a pretty bad dilemma. My 2-week vacation hasn't been very timely in this respect either.
Comment 27 vitar 2011-07-26 00:41:39 PDT
(In reply to comment #26)
This "pretty bad dilemma" can b solved very easily if to interpret (I speaks about a user-side) a WGL like a some plugin in a Google Chrome or for example images or cookies in a Firefox -- with 1) global enabling/disabling then 2) a kind of whitelist and 3) a some handy (like a current redirection or extension installation warning) notification.

I.e. let user to see a notify bar on top of page with choices "allow", "not now" and "add to whitelist" (of course a "chrome:" shall b observed too). This way 1) a FF can contain any (not only latest) build of WGL, 2) this stuff will not run everywhere (this zeroes any additional security risks) and 3) users still able to use this technology when they'r really need it.
Comment 28 Benoit Jacob [:bjacob] (mostly away) 2011-07-26 05:49:15 PDT
Current plan is to solve this by dynamically loading instead of linking to dwmapi.dll. Patch coming.
Comment 29 daniel-bzmz 2011-07-26 05:52:05 PDT
(In reply to comment #28)
> Current plan is to solve this by dynamically loading instead of linking to
> dwmapi.dll. Patch coming.

So your build system really doesn't support delay loading? That's unfortunate.
Comment 30 Benoit Jacob [:bjacob] (mostly away) 2011-07-26 05:59:12 PDT
(In reply to comment #29)
> (In reply to comment #28)
> > Current plan is to solve this by dynamically loading instead of linking to
> > dwmapi.dll. Patch coming.
> 
> So your build system really doesn't support delay loading? That's
> unfortunate.

I didn't say that :-) We can pass any compiler/linker flags from our makefiles, but in this case when I tried I got a different error: comment 22.

I'm sure this could be solved but I haven't found how, yet. Maybe I'll give it another try.
Comment 31 Benoit Jacob [:bjacob] (mostly away) 2011-07-26 08:33:59 PDT
Created attachment 548473 [details] [diff] [review]
delay-load dwmapi.dll

It turns out that I needed to link to delayimp.lib! Sorry it took me so long to figure.

New try-builds should soon be available at:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/bjacob@mozilla.com-3f6f63d154d2
Comment 32 Benoit Jacob [:bjacob] (mostly away) 2011-07-26 15:12:13 PDT
Created attachment 548608 [details] [diff] [review]
delayload dwmapi.dll and remove list of tests failing only on WinXP

Ta-daaah it works, and even better than anticipated: all the tests that were known to fail only on WinXP slaves now succeed. That means that the reason why they failed was not, as I thought, that WinXP slaves have older drivers than Win7 slaves; it is that the WinXP slaves were falling back to OpenGL drivers while Win7 slaves were using ANGLE!
Comment 33 jonrandy 2011-07-26 18:39:57 PDT
Confirmed - works for me too - and seems a bit faster than before. This is the first time I've looked at 8.0 too - looking very good and noticeably faster all round! Will we see this WebGL fix go into the Aurora channel before Aurora moves to 8.0?
Comment 34 Benoit Jacob [:bjacob] (mostly away) 2011-07-26 21:22:25 PDT
Great! Of course it will go into Firefox 6 and 7 too, to avoid having this big regression. The patch is very innocuous. Should be all landed tomorrow (Wednesday)
Comment 35 Benoit Jacob [:bjacob] (mostly away) 2011-07-27 11:55:51 PDT
On central:
http://hg.mozilla.org/mozilla-central/rev/c6332731227b
Comment 36 christian 2011-07-27 13:33:47 PDT
Comment on attachment 548608 [details] [diff] [review]
delayload dwmapi.dll and remove list of tests failing only on WinXP

Approved for mozilla-aurora and mozilla-beta
Comment 37 Benoit Jacob [:bjacob] (mostly away) 2011-07-27 14:35:51 PDT
Landed on Aurora and Beta:
http://hg.mozilla.org/releases/mozilla-aurora/rev/6b44a9964dc4
http://hg.mozilla.org/releases/mozilla-beta/rev/bd2dfb864da0
Comment 38 Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2011-09-22 15:42:42 PDT
qa- as no QA verification needed

Note You need to log in before you can comment on or make changes to this bug.